<template>
  <div>
    <slot
      v-bind:[name]="inner"
      v-bind:edited="edited"
      v-bind:original="original"
    >
      [ empty default slot ]
    </slot>
  </div>
</template>
<script>
export default {
  props: {
    value: {},
    name: { default: "value" },
    // Save key, if provided, we'll stash the changes in localStorage for later perusal:
    saveKey: { default: null },
  },
  data() {
    return {
      edited: false,
      inner: this.inner || this.value,
      original: JSON.parse(JSON.stringify(this.value)),
    };
  },
  mounted() {
    if (this.saveKey) {
      const saved = localStorage.getItem(this.saveKey);
      if (saved) this.$set(this, "inner", JSON.parse(saved));
    }
  },
  watch: {
    inner: {
      deep: true,
      handler: function (a, b) {
        this.edited = true;

        if (this.saveKey) {
          localStorage.setItem(this.saveKey, JSON.stringify(this.inner));
        }
      },
    },
    value: {
      deep: true,
      handler: function (a, b) {
        if (a != b) {
          this.original = JSON.parse(JSON.stringify(this.value));
          this.inner = this.value;

          // delay until after the inner handler gets triggered:
          this.$nextTick(() => {
            this.edited = false;
            if (this.saveKey) {
              localStorage.removeItem(this.saveKey);
            }
          });
        } else {
          this.edited = true;
        }
      },
    },
  },
  methods: {},
};
</script>
